<script setup lang="ts">
import DateFormat from '../libs/DateFormat';
import type { Person } from '@/types/Person';
import { ref } from 'vue';
import { truncateText } from '@/utils/truncateText';

const props = withDefaults(
  defineProps<{
    person: Person;
    maxBioLength?: number;
  }>(),
  { maxBioLength: 100 }
);

const bioNeedsTruncation = props.person.aboutMe?.length > props.maxBioLength;
const truncatedBio = props.person.aboutMe?.length ? truncateText(props.person.aboutMe, props.maxBioLength) : '';
const isBioExpanded = ref(false);
</script>

<template>
  <router-link :to="{ name: 'aboutperson', query: { id: props.person?.id } }" class="flex">
    <div class="flex flex-1 flex-col bg-white p-4 mt-8 shadow-xl rounded-3xl max-w-96 min-h-72">
      <div class="flex flex-col items-center mb-4 -mt-12">
        <img v-if="person?.image" :src="person.image" class="w-32 h-32 bg-white-900 image rounded-full border border-white" />
        <div v-else class="w-32 h-32 bg-sdg-background-light-grey flex justify-center items-center rounded-full border border-white overflow-hidden">
          <i class="fa-solid fa-user text-8xl mt-10 text-sdg-blue"></i>
        </div>
        <h2 class="text-3xl text-sdg-blue text-sdg mt-5 mb-2">{{ person.displayName }}</h2>
        <p class="font-normal text-lg">Hired {{ DateFormat.getYear(person.employeeHireDate) }}</p>
      </div>

      <div v-if="person.aboutMe">
        <h3 class="font-normal mb-2">Bio</h3>
        <p v-if="!bioNeedsTruncation || isBioExpanded" v-html="person.aboutMe" />
        <p v-else v-html="truncatedBio" />
        <button v-if="bioNeedsTruncation" @click.prevent="isBioExpanded = !isBioExpanded" class="text-sdg-blue text-lg font-normal mt-5">See {{ isBioExpanded ? 'Less' : 'More' }}</button>
      </div>
    </div>
  </router-link>
</template>
